	.NOLIST	

	.INCLUDE "2313def.inc"	

	.LIST	

	.CSEG			;kdov segment	

	.DEF REG=r22		;pracovny register

	.DEF CITAC=R16		;stupen na vystupe

	.def citac1=r20	;stupen na pake

	.def citac2=r24	;citac pre 4094

	.def sport=r23

	.EQU d=2		;datovy signal 4094

	.EQU CLK=3		;hodiny 4094

	.EQU str=4		;prepis vystupov 4094

	.def displ=r26		;znak pre lavy displej

	.equ T1=0		;tlacidlo up {volant}

	.equ t2=1		;tlacidlo down {volant}

	LDI Reg,$FF			

	OUT DDRD,Reg		;portd je vystupny

	ldi reg,0b00000000	

	out ddrb,reg		;portb je vstupny

	com reg			;log.0 je stlacene tlacidlo

	out portb,reg		;pull-up na portb

	ldi sport,0b11111111

	clr citac		;mazanie pomocnych citacov

	clr citac1

	clr citac2

	clr displ

INIC:	LDI Reg,RAMEND	

	OUT SPL,Reg		;spl na koniec ram

	clr reg			;vymaz pracovny register

	ldi sport,0b00000000

	sbis pinb,7

	ldi sport,0b11111111	

	

spzmena:sbrs sport,0

	ldi citac1,0	

	sbis pinb,0

	ldi citac1,-1

	sbis pinb,1

	ldi citac1,1

	sbis pinb,2

	ldi citac1,2

	sbis pinb,3

	ldi citac1,3

	sbis pinb,4

	ldi citac1,4

	sbis pinb,5

	ldi citac1,5

	sbis pinb,6		;ak je stlacene nejake

	ldi citac1,6		;tlacidlo->citac1

	cpi citac1,0		;ak je citac1 stale 0 

	sbrs sport,0

	breq neutral		;skoc na neutral

naspat:	rcall cekej		;pockaj

	cp citac1,citac	;porovnaj volant/paka

	breq rovnake		;skoc na rovnake

	brmi mensie		;alebo na mensie

	rjmp vacsie		;ak nie tak na vacsie

stupen:	cpi citac,0

	breq neutr

	cpi citac,1

	breq jedna

	cpi citac,2

	breq dva

	cpi citac,3

	breq tri

	cpi citac,4

	breq styri

	cpi citac,5

	breq pat

	cpi citac,6

	breq sest

	cpi citac,-1		;porovnaj citac s -1 az 6

	breq spat		;a skoc na aktualny stupen

	rjmp inic		;pre istotu, skoc na inic

jedna:	ldi reg,0b10110111	;_c__b___, vypisy

	rjmp cmosl		;	    na displej

dva:	ldi reg,0b11000010	;__deba_g	

	rjmp cmosl

tri:	ldi reg,0b10010010	;_cd_ba_g

	rjmp cmosl

styri:	ldi reg,0b10110100	;_c__b_fg

	rjmp cmosl

pat:	ldi reg,0b10011000	;_cd__afg

	rjmp cmosl

sest:	ldi reg,0b10001000	;_cde_afg

	rjmp cmosl

spat:	ldi reg,0b11101110	;___e___g

	rjmp cmosl

neutr:	ldi reg,0b10101110	;_c_e___g

	rjmp cmosl		;_CDEBAFG

zmena:	in r21,pinb

	com r21

	andi r21,0b01111111

	cpi r21,0

	brne spzmena

	ret

neutral:ldi r17,80		;nastav velkost pauzy

	ldi r18,255

	ldi r19,255

neutral1:dec r19		;a cakaj

	brne neutral1	

	dec r18

	brne neutral1

	rcall zmena

	dec r17 

	brne neutral1

	ldi citac1,0

	rjmp naspat		;skoc na naspat

rovnake:ldi displ,0b11111110	;lavy displej pomlcka

	rjmp stupen

mensie:	

	ldi displ,0b11011111	;lavy displej, sipka dole

	dec citac		;zniz citac

	sbi portd,t1

	ldi r17,2

	rcall cekejcvak

	cbi portd,t1

	rjmp stupen		;skoc na stupen {a vypis}

vacsie:	inc citac		;zvys citac

	ldi displ,0b11111011	;lavy displej, sipka hore

	sbi portd,t2

	ldi r17,2

	rcall cekejcvak

	cbi portd,t2

	rjmp stupen		;a na stupen

CEKEJ:	ldi r17,4

	sbrs sport,0

	LDI R17,10		;nastav velkost cakania

cekejcvak:

	LDI R18,0		

	LDI R19,0	

CEKEJA:	DEC R19	

	BRNE CEKEJA

	DEC R18	

	BRNE CEKEJA

	DEC R17	

	BRNE CEKEJA		;a cakaj

	RET			;navrat

cmosl:	cbi portd,str		;{vypis,lavy}log.0 do str

	cbi portd,clk		;log.0 do clk

	ldi citac2,8		;pocet cyklov

CMOSSl:	rol reg			;roluj register

	cbi portd,d		;log.0 na data

	brcc cmosal		;ak c=0 nenastav data

	sbi portd,d

cmosal:	sbi portd,clk		;impulz na clk

	cbi portd,clk

	dec citac2		;zniz pocitadlo

	brne cmossl		;nenulove=odosli dalsi bit 

	sbi portd,str		;bajt odoslany

	cbi portd,str		;impulz na str

	rol reg			;este raz zroluj reg

	cbr displ,0b10000000

	sbrs sport,0

	sbr displ,0b10000000

cmosp:	cbi portd,str		;{vypis,pravy}, ako cmosl

	cbi portd,clk

	ldi citac2,8

CMOSSp:	rol displ		;roluje sa displ

	cbi portd,d

	brcc cmosap

	sbi portd,d

cmosap:	sbi portd,clk

	cbi portd,clk

	dec citac2

	brne cmossp

	sbi portd,str

	cbi portd,str

	rol displ

	rjmp inic		;skoc na inic